#include <string.h>
#include <io.h>
#include <dir.h>
#include <fcntl.h>
#include <stdlib.h>

void FINDFILE(char *);
void ZAST(void);

#define MAXLEN 65535
typedef struct
{
      int  BM;
      long FZ;
      long U1;
      long HZ;
      long U2;
      long PX;
      long PY;
      int  U3;
      int  BP;
      long U4;
      long AP;
      char UP[16];
      char PL[1024];
}     BMPH;
unsigned char FILES[128][16],IMI[80],IMO[80],EXT[4],OPT[2];
unsigned char *D1,DD1,*D2,DD2,BB;
unsigned int N,II,I,J,A,ATTR,BITP,DLI;
long DLIF;
int FF1,FF2,FL;
BMPH HEDFI1,HEDFI2;

void FINDFILE(char *PATH)
{
     struct ffblk FIL;
     ATTR=0; FL=findfirst(PATH,&FIL,ATTR);
     if(FL==-1) { printf("\nAccess error\n"); exit(1); }
     N=0;
     while (FL==0 && N<128)
     {
        N=N+1;
        strcpy(FILES[N],FIL.ff_name);
        FL=findnext(&FIL);
     }
}

void ZAST(void)
{
     printf(" BMPROT.EXE - program for a rotate the image in a 256-colours\n");
     printf(" BMP-file; valid image size not more of 65536 pixels.\n");
     printf(" Usage: bmprot option filename targetext\n");
     printf("        Option is:\n");
     printf("               `L` - left\n");
     printf("               `R` - right\n");
     printf("               `H` - horizontal\n");
     printf("               `V` - vertical\n");
     printf("\n");
     printf(" If in a filename there are symbols `*` or `?`, the operation is\n");
     printf(" made with all files, satisfying specified to this mask of search,\n");
     printf(" `targetext` - extension for output files (`bmp`,`dib`,`rle`).\n");
     printf(" (E.H.Hauser, Baku, 05/04/01, 01:00:00, size 19612 bytes)\n");
     exit(0);
}

main(int argc, char *argv[])
{
    unsigned char PATH[80];
    if(argc!=4) ZAST();
    memset(PATH,0,80); memset(EXT,0,4);
    strcpy(OPT,strupr(argv[1])); strcpy(PATH,argv[2]); strcpy(EXT,argv[3]);
    FINDFILE(PATH);
    D1=(unsigned char *)calloc(MAXLEN,1); if(D1==NULL) exit(1);
    D2=(unsigned char *)calloc(MAXLEN,1); if(D2==NULL) exit(1);
    for(II=1;II<=N;II++)
    {
        memset(IMI,0,80); strcpy(IMI,strupr(FILES[II]));
        A=strcspn(IMI,"."); if(A<1) continue;
        memset(IMO,0,80); memcpy(IMO,IMI,A+1); strcat(IMO,EXT);
        FF1=open(IMI,O_RDONLY|O_BINARY);
        DLIF=filelength(FF1); if(DLIF>66614) { close(FF1); continue; }
        FF2=_creat(IMO,0); close(FF2);
        FF2=open(IMO,O_RDWR|O_BINARY);
        lseek(FF1,0,SEEK_SET); read(FF1,&HEDFI1,1078); HEDFI2=HEDFI1;
        DLI=HEDFI1.PX*HEDFI1.PY; read(FF1,D1,DLI);
        switch (OPT[0])
        {
               case 'R':
                    for(J=0;J<HEDFI1.PY;J++)
                        for(I=0;I<HEDFI1.PX;I++)
                            D2[I*HEDFI1.PY+J]=D1[(J+1)*HEDFI1.PX-I-1];
                    HEDFI2.PX=HEDFI1.PY; HEDFI2.PY=HEDFI1.PX;
                    break;
               case 'L':
                    for(J=0;J<HEDFI1.PY;J++)
                        for(I=0;I<HEDFI1.PX;I++)
                            D2[(I+1)*HEDFI1.PY-J-1]=D1[J*HEDFI1.PX+I];
                    HEDFI2.PX=HEDFI1.PY; HEDFI2.PY=HEDFI1.PX;
                    break;
               case 'H':
                    for(J=0;J<HEDFI1.PY;J++)
                        for(I=0;I<HEDFI1.PX;I++)
                            D2[(J+1)*HEDFI1.PX-I-1]=D1[J*HEDFI1.PX+I];
                    break;
               case 'V':
                    for(I=0;I<HEDFI1.PX;I++)
                        for(J=0;J<HEDFI1.PY;J++)
                            D2[(HEDFI1.PY-J-1)*HEDFI1.PX+I]=D1[J*HEDFI1.PX+I];
                    break;
               default:
                    close(FF1); close(FF2); free(D1); free(D2);
                    ZAST();
        }
        write(FF2,&HEDFI2,1078);
        write(FF2,D2,DLI);
        close(FF1); close(FF2);
    }
    free(D1); free(D2);
}
